// -*- C++ -*-
// $Id$

/**
 * Code generated by the The ACE ORB (TAO) IDL Compiler v2.2a_p14
 * TAO and the TAO IDL Compiler have been developed by:
 *       Center for Distributed Object Computing
 *       Washington University
 *       St. Louis, MO
 *       USA
 *       http://www.cs.wustl.edu/~schmidt/doc-center.html
 * and
 *       Distributed Object Computing Laboratory
 *       University of California at Irvine
 *       Irvine, CA
 *       USA
 * and
 *       Institute for Software Integrated Systems
 *       Vanderbilt University
 *       Nashville, TN
 *       USA
 *       http://www.isis.vanderbilt.edu/
 *
 * Information about TAO is available at:
 *     http://www.cs.wustl.edu/~schmidt/TAO.html
 **/

// TAO_IDL - Generated from
// be/be_codegen.cpp:152

#ifndef _TAO_IDL_FEDERATORTYPESUPPORTC_3EIWRQ_H_
#define _TAO_IDL_FEDERATORTYPESUPPORTC_3EIWRQ_H_

#include /**/ "ace/pre.h"


#include /**/ "ace/config-all.h"

#if !defined (ACE_LACKS_PRAGMA_ONCE)
# pragma once
#endif /* ACE_LACKS_PRAGMA_ONCE */


#include /**/ "federator_export.h"
#include "tao/ORB.h"
#include "tao/SystemException.h"
#include "tao/Basic_Types.h"
#include "tao/ORB_Constants.h"
#include "dds/DCPS/ZeroCopyInfoSeq_T.h"
#include "dds/DCPS/ZeroCopySeq_T.h"
#include "tao/Object.h"
#include "tao/String_Manager_T.h"
#include "tao/Sequence_T.h"
#include "tao/Objref_VarOut_T.h"
#include "tao/Seq_Var_T.h"
#include "tao/Seq_Out_T.h"
#include "tao/Arg_Traits_T.h"
#include "tao/Basic_Arguments.h"
#include "tao/Special_Basic_Arguments.h"
#include "tao/Any_Insert_Policy_T.h"
#include "tao/Fixed_Size_Argument_T.h"
#include "tao/Var_Size_Argument_T.h"
#include /**/ "tao/Version.h"
#include /**/ "tao/Versioned_Namespace.h"
#include /**/ "dds/Versioned_Namespace.h"

#include "FederatorC.h"
#include "dds/DdsDcpsPublicationC.h"
#include "dds/DdsDcpsInfrastructureC.h"
#include "dds/DdsDcpsSubscriptionExtC.h"
#include "dds/DdsDcpsTopicC.h"
#include "dds/DdsDcpsTypeSupportExtC.h"

#if TAO_MAJOR_VERSION != 2 || TAO_MINOR_VERSION != 2 || TAO_BETA_VERSION != 0
#error This file should be regenerated with TAO_IDL
#endif

#if defined (TAO_EXPORT_MACRO)
#undef TAO_EXPORT_MACRO
#endif
#define TAO_EXPORT_MACRO OpenDDS_Federator_Export

OPENDDS_BEGIN_VERSIONED_NAMESPACE_DECL



// TAO_IDL - Generated from
// be/be_visitor_module/module_ch.cpp:38

namespace OpenDDS
{

  // TAO_IDL - Generated from
  // be/be_visitor_module/module_ch.cpp:38

  namespace Federator
  {

    // TAO_IDL - Generated from
    // be/be_visitor_sequence/sequence_ch.cpp:102

    typedef ::TAO::DCPS::ZeroCopyDataSeq< OpenDDS::Federator::OwnerUpdate, DCPS_ZERO_COPY_SEQ_DEFAULT_SIZE> OwnerUpdateSeq;
    

    // TAO_IDL - Generated from
    // be/be_interface.cpp:751

#if !defined (_OPENDDS_FEDERATOR_OWNERUPDATETYPESUPPORT__VAR_OUT_CH_)
#define _OPENDDS_FEDERATOR_OWNERUPDATETYPESUPPORT__VAR_OUT_CH_

    class OwnerUpdateTypeSupport;
    typedef OwnerUpdateTypeSupport *OwnerUpdateTypeSupport_ptr;

    typedef
      TAO_Objref_Var_T<
          OwnerUpdateTypeSupport
        >
      OwnerUpdateTypeSupport_var;
    
    typedef
      TAO_Objref_Out_T<
          OwnerUpdateTypeSupport
        >
      OwnerUpdateTypeSupport_out;

#endif /* end #if !defined */

    // TAO_IDL - Generated from
    // be/be_visitor_interface/interface_ch.cpp:43

    class OpenDDS_Federator_Export OwnerUpdateTypeSupport
      : public virtual ::OpenDDS::DCPS::TypeSupport
    
    {
    public:

      // TAO_IDL - Generated from
      // be/be_type.cpp:307

      typedef OwnerUpdateTypeSupport_ptr _ptr_type;
      typedef OwnerUpdateTypeSupport_var _var_type;
      typedef OwnerUpdateTypeSupport_out _out_type;

      // The static operations.
      static OwnerUpdateTypeSupport_ptr _duplicate (OwnerUpdateTypeSupport_ptr obj);

      static void _tao_release (OwnerUpdateTypeSupport_ptr obj);

      static OwnerUpdateTypeSupport_ptr _narrow (::CORBA::Object_ptr obj);
      static OwnerUpdateTypeSupport_ptr _unchecked_narrow (::CORBA::Object_ptr obj);
      static OwnerUpdateTypeSupport_ptr _nil (void);

      // TAO_IDL - Generated from
      // be/be_visitor_interface/interface_ch.cpp:140

      virtual ::CORBA::Boolean _is_a (const char *type_id);
      virtual const char* _interface_repository_id (void) const;
      virtual ::CORBA::Boolean marshal (TAO_OutputCDR &cdr);
    
    protected:
      // Abstract or local interface only.
      OwnerUpdateTypeSupport (void);

      

      virtual ~OwnerUpdateTypeSupport (void);
    
    private:
      // Private and unimplemented for concrete interfaces.
      OwnerUpdateTypeSupport (const OwnerUpdateTypeSupport &);

      void operator= (const OwnerUpdateTypeSupport &);
    };

    // TAO_IDL - Generated from
    // be/be_interface.cpp:751

#if !defined (_OPENDDS_FEDERATOR_OWNERUPDATEDATAWRITER__VAR_OUT_CH_)
#define _OPENDDS_FEDERATOR_OWNERUPDATEDATAWRITER__VAR_OUT_CH_

    class OwnerUpdateDataWriter;
    typedef OwnerUpdateDataWriter *OwnerUpdateDataWriter_ptr;

    typedef
      TAO_Objref_Var_T<
          OwnerUpdateDataWriter
        >
      OwnerUpdateDataWriter_var;
    
    typedef
      TAO_Objref_Out_T<
          OwnerUpdateDataWriter
        >
      OwnerUpdateDataWriter_out;

#endif /* end #if !defined */

    // TAO_IDL - Generated from
    // be/be_visitor_interface/interface_ch.cpp:43

    class OpenDDS_Federator_Export OwnerUpdateDataWriter
      : public virtual ::DDS::DataWriter
    
    {
    public:

      // TAO_IDL - Generated from
      // be/be_type.cpp:307

      typedef OwnerUpdateDataWriter_ptr _ptr_type;
      typedef OwnerUpdateDataWriter_var _var_type;
      typedef OwnerUpdateDataWriter_out _out_type;

      // The static operations.
      static OwnerUpdateDataWriter_ptr _duplicate (OwnerUpdateDataWriter_ptr obj);

      static void _tao_release (OwnerUpdateDataWriter_ptr obj);

      static OwnerUpdateDataWriter_ptr _narrow (::CORBA::Object_ptr obj);
      static OwnerUpdateDataWriter_ptr _unchecked_narrow (::CORBA::Object_ptr obj);
      static OwnerUpdateDataWriter_ptr _nil (void);

      virtual ::DDS::InstanceHandle_t register_instance (
        const ::OpenDDS::Federator::OwnerUpdate & instance) = 0;

      virtual ::DDS::InstanceHandle_t register_instance_w_timestamp (
        const ::OpenDDS::Federator::OwnerUpdate & instance,
        const ::DDS::Time_t & timestamp) = 0;

      virtual ::DDS::ReturnCode_t unregister_instance (
        const ::OpenDDS::Federator::OwnerUpdate & instance,
        ::DDS::InstanceHandle_t handle) = 0;

      virtual ::DDS::ReturnCode_t unregister_instance_w_timestamp (
        const ::OpenDDS::Federator::OwnerUpdate & instance,
        ::DDS::InstanceHandle_t handle,
        const ::DDS::Time_t & timestamp) = 0;

      virtual ::DDS::ReturnCode_t write (
        const ::OpenDDS::Federator::OwnerUpdate & instance_data,
        ::DDS::InstanceHandle_t handle) = 0;

      virtual ::DDS::ReturnCode_t write_w_timestamp (
        const ::OpenDDS::Federator::OwnerUpdate & instance_data,
        ::DDS::InstanceHandle_t handle,
        const ::DDS::Time_t & source_timestamp) = 0;

      virtual ::DDS::ReturnCode_t dispose (
        const ::OpenDDS::Federator::OwnerUpdate & instance_data,
        ::DDS::InstanceHandle_t instance_handle) = 0;

      virtual ::DDS::ReturnCode_t dispose_w_timestamp (
        const ::OpenDDS::Federator::OwnerUpdate & instance_data,
        ::DDS::InstanceHandle_t instance_handle,
        const ::DDS::Time_t & source_timestamp) = 0;

      virtual ::DDS::ReturnCode_t get_key_value (
        ::OpenDDS::Federator::OwnerUpdate & key_holder,
        ::DDS::InstanceHandle_t handle) = 0;

      virtual ::DDS::InstanceHandle_t lookup_instance (
        const ::OpenDDS::Federator::OwnerUpdate & instance_data) = 0;

      // TAO_IDL - Generated from
      // be/be_visitor_interface/interface_ch.cpp:140

      virtual ::CORBA::Boolean _is_a (const char *type_id);
      virtual const char* _interface_repository_id (void) const;
      virtual ::CORBA::Boolean marshal (TAO_OutputCDR &cdr);
    
    protected:
      // Abstract or local interface only.
      OwnerUpdateDataWriter (void);

      

      virtual ~OwnerUpdateDataWriter (void);
    
    private:
      // Private and unimplemented for concrete interfaces.
      OwnerUpdateDataWriter (const OwnerUpdateDataWriter &);

      void operator= (const OwnerUpdateDataWriter &);
    };

    // TAO_IDL - Generated from
    // be/be_interface.cpp:751

#if !defined (_OPENDDS_FEDERATOR_OWNERUPDATEDATAREADER__VAR_OUT_CH_)
#define _OPENDDS_FEDERATOR_OWNERUPDATEDATAREADER__VAR_OUT_CH_

    class OwnerUpdateDataReader;
    typedef OwnerUpdateDataReader *OwnerUpdateDataReader_ptr;

    typedef
      TAO_Objref_Var_T<
          OwnerUpdateDataReader
        >
      OwnerUpdateDataReader_var;
    
    typedef
      TAO_Objref_Out_T<
          OwnerUpdateDataReader
        >
      OwnerUpdateDataReader_out;

#endif /* end #if !defined */

    // TAO_IDL - Generated from
    // be/be_visitor_interface/interface_ch.cpp:43

    class OpenDDS_Federator_Export OwnerUpdateDataReader
      : public virtual ::OpenDDS::DCPS::DataReaderEx
    
    {
    public:

      // TAO_IDL - Generated from
      // be/be_type.cpp:307

      typedef OwnerUpdateDataReader_ptr _ptr_type;
      typedef OwnerUpdateDataReader_var _var_type;
      typedef OwnerUpdateDataReader_out _out_type;

      // The static operations.
      static OwnerUpdateDataReader_ptr _duplicate (OwnerUpdateDataReader_ptr obj);

      static void _tao_release (OwnerUpdateDataReader_ptr obj);

      static OwnerUpdateDataReader_ptr _narrow (::CORBA::Object_ptr obj);
      static OwnerUpdateDataReader_ptr _unchecked_narrow (::CORBA::Object_ptr obj);
      static OwnerUpdateDataReader_ptr _nil (void);

      virtual ::DDS::ReturnCode_t read (
        ::OpenDDS::Federator::OwnerUpdateSeq & received_data,
        ::DDS::SampleInfoSeq & info_seq,
        ::CORBA::Long max_samples,
        ::DDS::SampleStateMask sample_states,
        ::DDS::ViewStateMask view_states,
        ::DDS::InstanceStateMask instance_states) = 0;

      virtual ::DDS::ReturnCode_t take (
        ::OpenDDS::Federator::OwnerUpdateSeq & received_data,
        ::DDS::SampleInfoSeq & info_seq,
        ::CORBA::Long max_samples,
        ::DDS::SampleStateMask sample_states,
        ::DDS::ViewStateMask view_states,
        ::DDS::InstanceStateMask instance_states) = 0;

      virtual ::DDS::ReturnCode_t read_w_condition (
        ::OpenDDS::Federator::OwnerUpdateSeq & data_values,
        ::DDS::SampleInfoSeq & sample_infos,
        ::CORBA::Long max_samples,
        ::DDS::ReadCondition_ptr a_condition) = 0;

      virtual ::DDS::ReturnCode_t take_w_condition (
        ::OpenDDS::Federator::OwnerUpdateSeq & data_values,
        ::DDS::SampleInfoSeq & sample_infos,
        ::CORBA::Long max_samples,
        ::DDS::ReadCondition_ptr a_condition) = 0;

      virtual ::DDS::ReturnCode_t read_next_sample (
        ::OpenDDS::Federator::OwnerUpdate & received_data,
        ::DDS::SampleInfo & sample_info) = 0;

      virtual ::DDS::ReturnCode_t take_next_sample (
        ::OpenDDS::Federator::OwnerUpdate & received_data,
        ::DDS::SampleInfo & sample_info) = 0;

      virtual ::DDS::ReturnCode_t read_instance (
        ::OpenDDS::Federator::OwnerUpdateSeq & received_data,
        ::DDS::SampleInfoSeq & info_seq,
        ::CORBA::Long max_samples,
        ::DDS::InstanceHandle_t a_handle,
        ::DDS::SampleStateMask sample_states,
        ::DDS::ViewStateMask view_states,
        ::DDS::InstanceStateMask instance_states) = 0;

      virtual ::DDS::ReturnCode_t take_instance (
        ::OpenDDS::Federator::OwnerUpdateSeq & received_data,
        ::DDS::SampleInfoSeq & info_seq,
        ::CORBA::Long max_samples,
        ::DDS::InstanceHandle_t a_handle,
        ::DDS::SampleStateMask sample_states,
        ::DDS::ViewStateMask view_states,
        ::DDS::InstanceStateMask instance_states) = 0;

      virtual ::DDS::ReturnCode_t read_instance_w_condition (
        ::OpenDDS::Federator::OwnerUpdateSeq & received_data,
        ::DDS::SampleInfoSeq & sample_infos,
        ::CORBA::Long max_samples,
        ::DDS::InstanceHandle_t a_handle,
        ::DDS::ReadCondition_ptr a_condition) = 0;

      virtual ::DDS::ReturnCode_t take_instance_w_condition (
        ::OpenDDS::Federator::OwnerUpdateSeq & received_data,
        ::DDS::SampleInfoSeq & sample_infos,
        ::CORBA::Long max_samples,
        ::DDS::InstanceHandle_t a_handle,
        ::DDS::ReadCondition_ptr a_condition) = 0;

      virtual ::DDS::ReturnCode_t read_next_instance (
        ::OpenDDS::Federator::OwnerUpdateSeq & received_data,
        ::DDS::SampleInfoSeq & info_seq,
        ::CORBA::Long max_samples,
        ::DDS::InstanceHandle_t a_handle,
        ::DDS::SampleStateMask sample_states,
        ::DDS::ViewStateMask view_states,
        ::DDS::InstanceStateMask instance_states) = 0;

      virtual ::DDS::ReturnCode_t take_next_instance (
        ::OpenDDS::Federator::OwnerUpdateSeq & received_data,
        ::DDS::SampleInfoSeq & info_seq,
        ::CORBA::Long max_samples,
        ::DDS::InstanceHandle_t a_handle,
        ::DDS::SampleStateMask sample_states,
        ::DDS::ViewStateMask view_states,
        ::DDS::InstanceStateMask instance_states) = 0;

      virtual ::DDS::ReturnCode_t read_next_instance_w_condition (
        ::OpenDDS::Federator::OwnerUpdateSeq & data_values,
        ::DDS::SampleInfoSeq & sample_infos,
        ::CORBA::Long max_samples,
        ::DDS::InstanceHandle_t previous_handle,
        ::DDS::ReadCondition_ptr a_condition) = 0;

      virtual ::DDS::ReturnCode_t take_next_instance_w_condition (
        ::OpenDDS::Federator::OwnerUpdateSeq & data_values,
        ::DDS::SampleInfoSeq & sample_infos,
        ::CORBA::Long max_samples,
        ::DDS::InstanceHandle_t previous_handle,
        ::DDS::ReadCondition_ptr a_condition) = 0;

      virtual ::DDS::ReturnCode_t return_loan (
        ::OpenDDS::Federator::OwnerUpdateSeq & received_data,
        ::DDS::SampleInfoSeq & info_seq) = 0;

      virtual ::DDS::ReturnCode_t get_key_value (
        ::OpenDDS::Federator::OwnerUpdate & key_holder,
        ::DDS::InstanceHandle_t handle) = 0;

      virtual ::DDS::InstanceHandle_t lookup_instance (
        const ::OpenDDS::Federator::OwnerUpdate & instance_data) = 0;

      // TAO_IDL - Generated from
      // be/be_visitor_interface/interface_ch.cpp:140

      virtual ::CORBA::Boolean _is_a (const char *type_id);
      virtual const char* _interface_repository_id (void) const;
      virtual ::CORBA::Boolean marshal (TAO_OutputCDR &cdr);
    
    protected:
      // Abstract or local interface only.
      OwnerUpdateDataReader (void);

      

      virtual ~OwnerUpdateDataReader (void);
    
    private:
      // Private and unimplemented for concrete interfaces.
      OwnerUpdateDataReader (const OwnerUpdateDataReader &);

      void operator= (const OwnerUpdateDataReader &);
    };
  
  // TAO_IDL - Generated from
  // be/be_visitor_module/module_ch.cpp:67
  
  } // module OpenDDS::Federator

// TAO_IDL - Generated from
// be/be_visitor_module/module_ch.cpp:67

} // module OpenDDS

// TAO_IDL - Generated from
// be/be_visitor_module/module_ch.cpp:38

namespace OpenDDS
{

  // TAO_IDL - Generated from
  // be/be_visitor_module/module_ch.cpp:38

  namespace Federator
  {

    // TAO_IDL - Generated from
    // be/be_visitor_sequence/sequence_ch.cpp:102

    typedef ::TAO::DCPS::ZeroCopyDataSeq< OpenDDS::Federator::TopicUpdate, DCPS_ZERO_COPY_SEQ_DEFAULT_SIZE> TopicUpdateSeq;
    

    // TAO_IDL - Generated from
    // be/be_interface.cpp:751

#if !defined (_OPENDDS_FEDERATOR_TOPICUPDATETYPESUPPORT__VAR_OUT_CH_)
#define _OPENDDS_FEDERATOR_TOPICUPDATETYPESUPPORT__VAR_OUT_CH_

    class TopicUpdateTypeSupport;
    typedef TopicUpdateTypeSupport *TopicUpdateTypeSupport_ptr;

    typedef
      TAO_Objref_Var_T<
          TopicUpdateTypeSupport
        >
      TopicUpdateTypeSupport_var;
    
    typedef
      TAO_Objref_Out_T<
          TopicUpdateTypeSupport
        >
      TopicUpdateTypeSupport_out;

#endif /* end #if !defined */

    // TAO_IDL - Generated from
    // be/be_visitor_interface/interface_ch.cpp:43

    class OpenDDS_Federator_Export TopicUpdateTypeSupport
      : public virtual ::OpenDDS::DCPS::TypeSupport
    
    {
    public:

      // TAO_IDL - Generated from
      // be/be_type.cpp:307

      typedef TopicUpdateTypeSupport_ptr _ptr_type;
      typedef TopicUpdateTypeSupport_var _var_type;
      typedef TopicUpdateTypeSupport_out _out_type;

      // The static operations.
      static TopicUpdateTypeSupport_ptr _duplicate (TopicUpdateTypeSupport_ptr obj);

      static void _tao_release (TopicUpdateTypeSupport_ptr obj);

      static TopicUpdateTypeSupport_ptr _narrow (::CORBA::Object_ptr obj);
      static TopicUpdateTypeSupport_ptr _unchecked_narrow (::CORBA::Object_ptr obj);
      static TopicUpdateTypeSupport_ptr _nil (void);

      // TAO_IDL - Generated from
      // be/be_visitor_interface/interface_ch.cpp:140

      virtual ::CORBA::Boolean _is_a (const char *type_id);
      virtual const char* _interface_repository_id (void) const;
      virtual ::CORBA::Boolean marshal (TAO_OutputCDR &cdr);
    
    protected:
      // Abstract or local interface only.
      TopicUpdateTypeSupport (void);

      

      virtual ~TopicUpdateTypeSupport (void);
    
    private:
      // Private and unimplemented for concrete interfaces.
      TopicUpdateTypeSupport (const TopicUpdateTypeSupport &);

      void operator= (const TopicUpdateTypeSupport &);
    };

    // TAO_IDL - Generated from
    // be/be_interface.cpp:751

#if !defined (_OPENDDS_FEDERATOR_TOPICUPDATEDATAWRITER__VAR_OUT_CH_)
#define _OPENDDS_FEDERATOR_TOPICUPDATEDATAWRITER__VAR_OUT_CH_

    class TopicUpdateDataWriter;
    typedef TopicUpdateDataWriter *TopicUpdateDataWriter_ptr;

    typedef
      TAO_Objref_Var_T<
          TopicUpdateDataWriter
        >
      TopicUpdateDataWriter_var;
    
    typedef
      TAO_Objref_Out_T<
          TopicUpdateDataWriter
        >
      TopicUpdateDataWriter_out;

#endif /* end #if !defined */

    // TAO_IDL - Generated from
    // be/be_visitor_interface/interface_ch.cpp:43

    class OpenDDS_Federator_Export TopicUpdateDataWriter
      : public virtual ::DDS::DataWriter
    
    {
    public:

      // TAO_IDL - Generated from
      // be/be_type.cpp:307

      typedef TopicUpdateDataWriter_ptr _ptr_type;
      typedef TopicUpdateDataWriter_var _var_type;
      typedef TopicUpdateDataWriter_out _out_type;

      // The static operations.
      static TopicUpdateDataWriter_ptr _duplicate (TopicUpdateDataWriter_ptr obj);

      static void _tao_release (TopicUpdateDataWriter_ptr obj);

      static TopicUpdateDataWriter_ptr _narrow (::CORBA::Object_ptr obj);
      static TopicUpdateDataWriter_ptr _unchecked_narrow (::CORBA::Object_ptr obj);
      static TopicUpdateDataWriter_ptr _nil (void);

      virtual ::DDS::InstanceHandle_t register_instance (
        const ::OpenDDS::Federator::TopicUpdate & instance) = 0;

      virtual ::DDS::InstanceHandle_t register_instance_w_timestamp (
        const ::OpenDDS::Federator::TopicUpdate & instance,
        const ::DDS::Time_t & timestamp) = 0;

      virtual ::DDS::ReturnCode_t unregister_instance (
        const ::OpenDDS::Federator::TopicUpdate & instance,
        ::DDS::InstanceHandle_t handle) = 0;

      virtual ::DDS::ReturnCode_t unregister_instance_w_timestamp (
        const ::OpenDDS::Federator::TopicUpdate & instance,
        ::DDS::InstanceHandle_t handle,
        const ::DDS::Time_t & timestamp) = 0;

      virtual ::DDS::ReturnCode_t write (
        const ::OpenDDS::Federator::TopicUpdate & instance_data,
        ::DDS::InstanceHandle_t handle) = 0;

      virtual ::DDS::ReturnCode_t write_w_timestamp (
        const ::OpenDDS::Federator::TopicUpdate & instance_data,
        ::DDS::InstanceHandle_t handle,
        const ::DDS::Time_t & source_timestamp) = 0;

      virtual ::DDS::ReturnCode_t dispose (
        const ::OpenDDS::Federator::TopicUpdate & instance_data,
        ::DDS::InstanceHandle_t instance_handle) = 0;

      virtual ::DDS::ReturnCode_t dispose_w_timestamp (
        const ::OpenDDS::Federator::TopicUpdate & instance_data,
        ::DDS::InstanceHandle_t instance_handle,
        const ::DDS::Time_t & source_timestamp) = 0;

      virtual ::DDS::ReturnCode_t get_key_value (
        ::OpenDDS::Federator::TopicUpdate & key_holder,
        ::DDS::InstanceHandle_t handle) = 0;

      virtual ::DDS::InstanceHandle_t lookup_instance (
        const ::OpenDDS::Federator::TopicUpdate & instance_data) = 0;

      // TAO_IDL - Generated from
      // be/be_visitor_interface/interface_ch.cpp:140

      virtual ::CORBA::Boolean _is_a (const char *type_id);
      virtual const char* _interface_repository_id (void) const;
      virtual ::CORBA::Boolean marshal (TAO_OutputCDR &cdr);
    
    protected:
      // Abstract or local interface only.
      TopicUpdateDataWriter (void);

      

      virtual ~TopicUpdateDataWriter (void);
    
    private:
      // Private and unimplemented for concrete interfaces.
      TopicUpdateDataWriter (const TopicUpdateDataWriter &);

      void operator= (const TopicUpdateDataWriter &);
    };

    // TAO_IDL - Generated from
    // be/be_interface.cpp:751

#if !defined (_OPENDDS_FEDERATOR_TOPICUPDATEDATAREADER__VAR_OUT_CH_)
#define _OPENDDS_FEDERATOR_TOPICUPDATEDATAREADER__VAR_OUT_CH_

    class TopicUpdateDataReader;
    typedef TopicUpdateDataReader *TopicUpdateDataReader_ptr;

    typedef
      TAO_Objref_Var_T<
          TopicUpdateDataReader
        >
      TopicUpdateDataReader_var;
    
    typedef
      TAO_Objref_Out_T<
          TopicUpdateDataReader
        >
      TopicUpdateDataReader_out;

#endif /* end #if !defined */

    // TAO_IDL - Generated from
    // be/be_visitor_interface/interface_ch.cpp:43

    class OpenDDS_Federator_Export TopicUpdateDataReader
      : public virtual ::OpenDDS::DCPS::DataReaderEx
    
    {
    public:

      // TAO_IDL - Generated from
      // be/be_type.cpp:307

      typedef TopicUpdateDataReader_ptr _ptr_type;
      typedef TopicUpdateDataReader_var _var_type;
      typedef TopicUpdateDataReader_out _out_type;

      // The static operations.
      static TopicUpdateDataReader_ptr _duplicate (TopicUpdateDataReader_ptr obj);

      static void _tao_release (TopicUpdateDataReader_ptr obj);

      static TopicUpdateDataReader_ptr _narrow (::CORBA::Object_ptr obj);
      static TopicUpdateDataReader_ptr _unchecked_narrow (::CORBA::Object_ptr obj);
      static TopicUpdateDataReader_ptr _nil (void);

      virtual ::DDS::ReturnCode_t read (
        ::OpenDDS::Federator::TopicUpdateSeq & received_data,
        ::DDS::SampleInfoSeq & info_seq,
        ::CORBA::Long max_samples,
        ::DDS::SampleStateMask sample_states,
        ::DDS::ViewStateMask view_states,
        ::DDS::InstanceStateMask instance_states) = 0;

      virtual ::DDS::ReturnCode_t take (
        ::OpenDDS::Federator::TopicUpdateSeq & received_data,
        ::DDS::SampleInfoSeq & info_seq,
        ::CORBA::Long max_samples,
        ::DDS::SampleStateMask sample_states,
        ::DDS::ViewStateMask view_states,
        ::DDS::InstanceStateMask instance_states) = 0;

      virtual ::DDS::ReturnCode_t read_w_condition (
        ::OpenDDS::Federator::TopicUpdateSeq & data_values,
        ::DDS::SampleInfoSeq & sample_infos,
        ::CORBA::Long max_samples,
        ::DDS::ReadCondition_ptr a_condition) = 0;

      virtual ::DDS::ReturnCode_t take_w_condition (
        ::OpenDDS::Federator::TopicUpdateSeq & data_values,
        ::DDS::SampleInfoSeq & sample_infos,
        ::CORBA::Long max_samples,
        ::DDS::ReadCondition_ptr a_condition) = 0;

      virtual ::DDS::ReturnCode_t read_next_sample (
        ::OpenDDS::Federator::TopicUpdate & received_data,
        ::DDS::SampleInfo & sample_info) = 0;

      virtual ::DDS::ReturnCode_t take_next_sample (
        ::OpenDDS::Federator::TopicUpdate & received_data,
        ::DDS::SampleInfo & sample_info) = 0;

      virtual ::DDS::ReturnCode_t read_instance (
        ::OpenDDS::Federator::TopicUpdateSeq & received_data,
        ::DDS::SampleInfoSeq & info_seq,
        ::CORBA::Long max_samples,
        ::DDS::InstanceHandle_t a_handle,
        ::DDS::SampleStateMask sample_states,
        ::DDS::ViewStateMask view_states,
        ::DDS::InstanceStateMask instance_states) = 0;

      virtual ::DDS::ReturnCode_t take_instance (
        ::OpenDDS::Federator::TopicUpdateSeq & received_data,
        ::DDS::SampleInfoSeq & info_seq,
        ::CORBA::Long max_samples,
        ::DDS::InstanceHandle_t a_handle,
        ::DDS::SampleStateMask sample_states,
        ::DDS::ViewStateMask view_states,
        ::DDS::InstanceStateMask instance_states) = 0;

      virtual ::DDS::ReturnCode_t read_instance_w_condition (
        ::OpenDDS::Federator::TopicUpdateSeq & received_data,
        ::DDS::SampleInfoSeq & sample_infos,
        ::CORBA::Long max_samples,
        ::DDS::InstanceHandle_t a_handle,
        ::DDS::ReadCondition_ptr a_condition) = 0;

      virtual ::DDS::ReturnCode_t take_instance_w_condition (
        ::OpenDDS::Federator::TopicUpdateSeq & received_data,
        ::DDS::SampleInfoSeq & sample_infos,
        ::CORBA::Long max_samples,
        ::DDS::InstanceHandle_t a_handle,
        ::DDS::ReadCondition_ptr a_condition) = 0;

      virtual ::DDS::ReturnCode_t read_next_instance (
        ::OpenDDS::Federator::TopicUpdateSeq & received_data,
        ::DDS::SampleInfoSeq & info_seq,
        ::CORBA::Long max_samples,
        ::DDS::InstanceHandle_t a_handle,
        ::DDS::SampleStateMask sample_states,
        ::DDS::ViewStateMask view_states,
        ::DDS::InstanceStateMask instance_states) = 0;

      virtual ::DDS::ReturnCode_t take_next_instance (
        ::OpenDDS::Federator::TopicUpdateSeq & received_data,
        ::DDS::SampleInfoSeq & info_seq,
        ::CORBA::Long max_samples,
        ::DDS::InstanceHandle_t a_handle,
        ::DDS::SampleStateMask sample_states,
        ::DDS::ViewStateMask view_states,
        ::DDS::InstanceStateMask instance_states) = 0;

      virtual ::DDS::ReturnCode_t read_next_instance_w_condition (
        ::OpenDDS::Federator::TopicUpdateSeq & data_values,
        ::DDS::SampleInfoSeq & sample_infos,
        ::CORBA::Long max_samples,
        ::DDS::InstanceHandle_t previous_handle,
        ::DDS::ReadCondition_ptr a_condition) = 0;

      virtual ::DDS::ReturnCode_t take_next_instance_w_condition (
        ::OpenDDS::Federator::TopicUpdateSeq & data_values,
        ::DDS::SampleInfoSeq & sample_infos,
        ::CORBA::Long max_samples,
        ::DDS::InstanceHandle_t previous_handle,
        ::DDS::ReadCondition_ptr a_condition) = 0;

      virtual ::DDS::ReturnCode_t return_loan (
        ::OpenDDS::Federator::TopicUpdateSeq & received_data,
        ::DDS::SampleInfoSeq & info_seq) = 0;

      virtual ::DDS::ReturnCode_t get_key_value (
        ::OpenDDS::Federator::TopicUpdate & key_holder,
        ::DDS::InstanceHandle_t handle) = 0;

      virtual ::DDS::InstanceHandle_t lookup_instance (
        const ::OpenDDS::Federator::TopicUpdate & instance_data) = 0;

      // TAO_IDL - Generated from
      // be/be_visitor_interface/interface_ch.cpp:140

      virtual ::CORBA::Boolean _is_a (const char *type_id);
      virtual const char* _interface_repository_id (void) const;
      virtual ::CORBA::Boolean marshal (TAO_OutputCDR &cdr);
    
    protected:
      // Abstract or local interface only.
      TopicUpdateDataReader (void);

      

      virtual ~TopicUpdateDataReader (void);
    
    private:
      // Private and unimplemented for concrete interfaces.
      TopicUpdateDataReader (const TopicUpdateDataReader &);

      void operator= (const TopicUpdateDataReader &);
    };
  
  // TAO_IDL - Generated from
  // be/be_visitor_module/module_ch.cpp:67
  
  } // module OpenDDS::Federator

// TAO_IDL - Generated from
// be/be_visitor_module/module_ch.cpp:67

} // module OpenDDS

// TAO_IDL - Generated from
// be/be_visitor_module/module_ch.cpp:38

namespace OpenDDS
{

  // TAO_IDL - Generated from
  // be/be_visitor_module/module_ch.cpp:38

  namespace Federator
  {

    // TAO_IDL - Generated from
    // be/be_visitor_sequence/sequence_ch.cpp:102

    typedef ::TAO::DCPS::ZeroCopyDataSeq< OpenDDS::Federator::ParticipantUpdate, DCPS_ZERO_COPY_SEQ_DEFAULT_SIZE> ParticipantUpdateSeq;
    

    // TAO_IDL - Generated from
    // be/be_interface.cpp:751

#if !defined (_OPENDDS_FEDERATOR_PARTICIPANTUPDATETYPESUPPORT__VAR_OUT_CH_)
#define _OPENDDS_FEDERATOR_PARTICIPANTUPDATETYPESUPPORT__VAR_OUT_CH_

    class ParticipantUpdateTypeSupport;
    typedef ParticipantUpdateTypeSupport *ParticipantUpdateTypeSupport_ptr;

    typedef
      TAO_Objref_Var_T<
          ParticipantUpdateTypeSupport
        >
      ParticipantUpdateTypeSupport_var;
    
    typedef
      TAO_Objref_Out_T<
          ParticipantUpdateTypeSupport
        >
      ParticipantUpdateTypeSupport_out;

#endif /* end #if !defined */

    // TAO_IDL - Generated from
    // be/be_visitor_interface/interface_ch.cpp:43

    class OpenDDS_Federator_Export ParticipantUpdateTypeSupport
      : public virtual ::OpenDDS::DCPS::TypeSupport
    
    {
    public:

      // TAO_IDL - Generated from
      // be/be_type.cpp:307

      typedef ParticipantUpdateTypeSupport_ptr _ptr_type;
      typedef ParticipantUpdateTypeSupport_var _var_type;
      typedef ParticipantUpdateTypeSupport_out _out_type;

      // The static operations.
      static ParticipantUpdateTypeSupport_ptr _duplicate (ParticipantUpdateTypeSupport_ptr obj);

      static void _tao_release (ParticipantUpdateTypeSupport_ptr obj);

      static ParticipantUpdateTypeSupport_ptr _narrow (::CORBA::Object_ptr obj);
      static ParticipantUpdateTypeSupport_ptr _unchecked_narrow (::CORBA::Object_ptr obj);
      static ParticipantUpdateTypeSupport_ptr _nil (void);

      // TAO_IDL - Generated from
      // be/be_visitor_interface/interface_ch.cpp:140

      virtual ::CORBA::Boolean _is_a (const char *type_id);
      virtual const char* _interface_repository_id (void) const;
      virtual ::CORBA::Boolean marshal (TAO_OutputCDR &cdr);
    
    protected:
      // Abstract or local interface only.
      ParticipantUpdateTypeSupport (void);

      

      virtual ~ParticipantUpdateTypeSupport (void);
    
    private:
      // Private and unimplemented for concrete interfaces.
      ParticipantUpdateTypeSupport (const ParticipantUpdateTypeSupport &);

      void operator= (const ParticipantUpdateTypeSupport &);
    };

    // TAO_IDL - Generated from
    // be/be_interface.cpp:751

#if !defined (_OPENDDS_FEDERATOR_PARTICIPANTUPDATEDATAWRITER__VAR_OUT_CH_)
#define _OPENDDS_FEDERATOR_PARTICIPANTUPDATEDATAWRITER__VAR_OUT_CH_

    class ParticipantUpdateDataWriter;
    typedef ParticipantUpdateDataWriter *ParticipantUpdateDataWriter_ptr;

    typedef
      TAO_Objref_Var_T<
          ParticipantUpdateDataWriter
        >
      ParticipantUpdateDataWriter_var;
    
    typedef
      TAO_Objref_Out_T<
          ParticipantUpdateDataWriter
        >
      ParticipantUpdateDataWriter_out;

#endif /* end #if !defined */

    // TAO_IDL - Generated from
    // be/be_visitor_interface/interface_ch.cpp:43

    class OpenDDS_Federator_Export ParticipantUpdateDataWriter
      : public virtual ::DDS::DataWriter
    
    {
    public:

      // TAO_IDL - Generated from
      // be/be_type.cpp:307

      typedef ParticipantUpdateDataWriter_ptr _ptr_type;
      typedef ParticipantUpdateDataWriter_var _var_type;
      typedef ParticipantUpdateDataWriter_out _out_type;

      // The static operations.
      static ParticipantUpdateDataWriter_ptr _duplicate (ParticipantUpdateDataWriter_ptr obj);

      static void _tao_release (ParticipantUpdateDataWriter_ptr obj);

      static ParticipantUpdateDataWriter_ptr _narrow (::CORBA::Object_ptr obj);
      static ParticipantUpdateDataWriter_ptr _unchecked_narrow (::CORBA::Object_ptr obj);
      static ParticipantUpdateDataWriter_ptr _nil (void);

      virtual ::DDS::InstanceHandle_t register_instance (
        const ::OpenDDS::Federator::ParticipantUpdate & instance) = 0;

      virtual ::DDS::InstanceHandle_t register_instance_w_timestamp (
        const ::OpenDDS::Federator::ParticipantUpdate & instance,
        const ::DDS::Time_t & timestamp) = 0;

      virtual ::DDS::ReturnCode_t unregister_instance (
        const ::OpenDDS::Federator::ParticipantUpdate & instance,
        ::DDS::InstanceHandle_t handle) = 0;

      virtual ::DDS::ReturnCode_t unregister_instance_w_timestamp (
        const ::OpenDDS::Federator::ParticipantUpdate & instance,
        ::DDS::InstanceHandle_t handle,
        const ::DDS::Time_t & timestamp) = 0;

      virtual ::DDS::ReturnCode_t write (
        const ::OpenDDS::Federator::ParticipantUpdate & instance_data,
        ::DDS::InstanceHandle_t handle) = 0;

      virtual ::DDS::ReturnCode_t write_w_timestamp (
        const ::OpenDDS::Federator::ParticipantUpdate & instance_data,
        ::DDS::InstanceHandle_t handle,
        const ::DDS::Time_t & source_timestamp) = 0;

      virtual ::DDS::ReturnCode_t dispose (
        const ::OpenDDS::Federator::ParticipantUpdate & instance_data,
        ::DDS::InstanceHandle_t instance_handle) = 0;

      virtual ::DDS::ReturnCode_t dispose_w_timestamp (
        const ::OpenDDS::Federator::ParticipantUpdate & instance_data,
        ::DDS::InstanceHandle_t instance_handle,
        const ::DDS::Time_t & source_timestamp) = 0;

      virtual ::DDS::ReturnCode_t get_key_value (
        ::OpenDDS::Federator::ParticipantUpdate & key_holder,
        ::DDS::InstanceHandle_t handle) = 0;

      virtual ::DDS::InstanceHandle_t lookup_instance (
        const ::OpenDDS::Federator::ParticipantUpdate & instance_data) = 0;

      // TAO_IDL - Generated from
      // be/be_visitor_interface/interface_ch.cpp:140

      virtual ::CORBA::Boolean _is_a (const char *type_id);
      virtual const char* _interface_repository_id (void) const;
      virtual ::CORBA::Boolean marshal (TAO_OutputCDR &cdr);
    
    protected:
      // Abstract or local interface only.
      ParticipantUpdateDataWriter (void);

      

      virtual ~ParticipantUpdateDataWriter (void);
    
    private:
      // Private and unimplemented for concrete interfaces.
      ParticipantUpdateDataWriter (const ParticipantUpdateDataWriter &);

      void operator= (const ParticipantUpdateDataWriter &);
    };

    // TAO_IDL - Generated from
    // be/be_interface.cpp:751

#if !defined (_OPENDDS_FEDERATOR_PARTICIPANTUPDATEDATAREADER__VAR_OUT_CH_)
#define _OPENDDS_FEDERATOR_PARTICIPANTUPDATEDATAREADER__VAR_OUT_CH_

    class ParticipantUpdateDataReader;
    typedef ParticipantUpdateDataReader *ParticipantUpdateDataReader_ptr;

    typedef
      TAO_Objref_Var_T<
          ParticipantUpdateDataReader
        >
      ParticipantUpdateDataReader_var;
    
    typedef
      TAO_Objref_Out_T<
          ParticipantUpdateDataReader
        >
      ParticipantUpdateDataReader_out;

#endif /* end #if !defined */

    // TAO_IDL - Generated from
    // be/be_visitor_interface/interface_ch.cpp:43

    class OpenDDS_Federator_Export ParticipantUpdateDataReader
      : public virtual ::OpenDDS::DCPS::DataReaderEx
    
    {
    public:

      // TAO_IDL - Generated from
      // be/be_type.cpp:307

      typedef ParticipantUpdateDataReader_ptr _ptr_type;
      typedef ParticipantUpdateDataReader_var _var_type;
      typedef ParticipantUpdateDataReader_out _out_type;

      // The static operations.
      static ParticipantUpdateDataReader_ptr _duplicate (ParticipantUpdateDataReader_ptr obj);

      static void _tao_release (ParticipantUpdateDataReader_ptr obj);

      static ParticipantUpdateDataReader_ptr _narrow (::CORBA::Object_ptr obj);
      static ParticipantUpdateDataReader_ptr _unchecked_narrow (::CORBA::Object_ptr obj);
      static ParticipantUpdateDataReader_ptr _nil (void);

      virtual ::DDS::ReturnCode_t read (
        ::OpenDDS::Federator::ParticipantUpdateSeq & received_data,
        ::DDS::SampleInfoSeq & info_seq,
        ::CORBA::Long max_samples,
        ::DDS::SampleStateMask sample_states,
        ::DDS::ViewStateMask view_states,
        ::DDS::InstanceStateMask instance_states) = 0;

      virtual ::DDS::ReturnCode_t take (
        ::OpenDDS::Federator::ParticipantUpdateSeq & received_data,
        ::DDS::SampleInfoSeq & info_seq,
        ::CORBA::Long max_samples,
        ::DDS::SampleStateMask sample_states,
        ::DDS::ViewStateMask view_states,
        ::DDS::InstanceStateMask instance_states) = 0;

      virtual ::DDS::ReturnCode_t read_w_condition (
        ::OpenDDS::Federator::ParticipantUpdateSeq & data_values,
        ::DDS::SampleInfoSeq & sample_infos,
        ::CORBA::Long max_samples,
        ::DDS::ReadCondition_ptr a_condition) = 0;

      virtual ::DDS::ReturnCode_t take_w_condition (
        ::OpenDDS::Federator::ParticipantUpdateSeq & data_values,
        ::DDS::SampleInfoSeq & sample_infos,
        ::CORBA::Long max_samples,
        ::DDS::ReadCondition_ptr a_condition) = 0;

      virtual ::DDS::ReturnCode_t read_next_sample (
        ::OpenDDS::Federator::ParticipantUpdate & received_data,
        ::DDS::SampleInfo & sample_info) = 0;

      virtual ::DDS::ReturnCode_t take_next_sample (
        ::OpenDDS::Federator::ParticipantUpdate & received_data,
        ::DDS::SampleInfo & sample_info) = 0;

      virtual ::DDS::ReturnCode_t read_instance (
        ::OpenDDS::Federator::ParticipantUpdateSeq & received_data,
        ::DDS::SampleInfoSeq & info_seq,
        ::CORBA::Long max_samples,
        ::DDS::InstanceHandle_t a_handle,
        ::DDS::SampleStateMask sample_states,
        ::DDS::ViewStateMask view_states,
        ::DDS::InstanceStateMask instance_states) = 0;

      virtual ::DDS::ReturnCode_t take_instance (
        ::OpenDDS::Federator::ParticipantUpdateSeq & received_data,
        ::DDS::SampleInfoSeq & info_seq,
        ::CORBA::Long max_samples,
        ::DDS::InstanceHandle_t a_handle,
        ::DDS::SampleStateMask sample_states,
        ::DDS::ViewStateMask view_states,
        ::DDS::InstanceStateMask instance_states) = 0;

      virtual ::DDS::ReturnCode_t read_instance_w_condition (
        ::OpenDDS::Federator::ParticipantUpdateSeq & received_data,
        ::DDS::SampleInfoSeq & sample_infos,
        ::CORBA::Long max_samples,
        ::DDS::InstanceHandle_t a_handle,
        ::DDS::ReadCondition_ptr a_condition) = 0;

      virtual ::DDS::ReturnCode_t take_instance_w_condition (
        ::OpenDDS::Federator::ParticipantUpdateSeq & received_data,
        ::DDS::SampleInfoSeq & sample_infos,
        ::CORBA::Long max_samples,
        ::DDS::InstanceHandle_t a_handle,
        ::DDS::ReadCondition_ptr a_condition) = 0;

      virtual ::DDS::ReturnCode_t read_next_instance (
        ::OpenDDS::Federator::ParticipantUpdateSeq & received_data,
        ::DDS::SampleInfoSeq & info_seq,
        ::CORBA::Long max_samples,
        ::DDS::InstanceHandle_t a_handle,
        ::DDS::SampleStateMask sample_states,
        ::DDS::ViewStateMask view_states,
        ::DDS::InstanceStateMask instance_states) = 0;

      virtual ::DDS::ReturnCode_t take_next_instance (
        ::OpenDDS::Federator::ParticipantUpdateSeq & received_data,
        ::DDS::SampleInfoSeq & info_seq,
        ::CORBA::Long max_samples,
        ::DDS::InstanceHandle_t a_handle,
        ::DDS::SampleStateMask sample_states,
        ::DDS::ViewStateMask view_states,
        ::DDS::InstanceStateMask instance_states) = 0;

      virtual ::DDS::ReturnCode_t read_next_instance_w_condition (
        ::OpenDDS::Federator::ParticipantUpdateSeq & data_values,
        ::DDS::SampleInfoSeq & sample_infos,
        ::CORBA::Long max_samples,
        ::DDS::InstanceHandle_t previous_handle,
        ::DDS::ReadCondition_ptr a_condition) = 0;

      virtual ::DDS::ReturnCode_t take_next_instance_w_condition (
        ::OpenDDS::Federator::ParticipantUpdateSeq & data_values,
        ::DDS::SampleInfoSeq & sample_infos,
        ::CORBA::Long max_samples,
        ::DDS::InstanceHandle_t previous_handle,
        ::DDS::ReadCondition_ptr a_condition) = 0;

      virtual ::DDS::ReturnCode_t return_loan (
        ::OpenDDS::Federator::ParticipantUpdateSeq & received_data,
        ::DDS::SampleInfoSeq & info_seq) = 0;

      virtual ::DDS::ReturnCode_t get_key_value (
        ::OpenDDS::Federator::ParticipantUpdate & key_holder,
        ::DDS::InstanceHandle_t handle) = 0;

      virtual ::DDS::InstanceHandle_t lookup_instance (
        const ::OpenDDS::Federator::ParticipantUpdate & instance_data) = 0;

      // TAO_IDL - Generated from
      // be/be_visitor_interface/interface_ch.cpp:140

      virtual ::CORBA::Boolean _is_a (const char *type_id);
      virtual const char* _interface_repository_id (void) const;
      virtual ::CORBA::Boolean marshal (TAO_OutputCDR &cdr);
    
    protected:
      // Abstract or local interface only.
      ParticipantUpdateDataReader (void);

      

      virtual ~ParticipantUpdateDataReader (void);
    
    private:
      // Private and unimplemented for concrete interfaces.
      ParticipantUpdateDataReader (const ParticipantUpdateDataReader &);

      void operator= (const ParticipantUpdateDataReader &);
    };
  
  // TAO_IDL - Generated from
  // be/be_visitor_module/module_ch.cpp:67
  
  } // module OpenDDS::Federator

// TAO_IDL - Generated from
// be/be_visitor_module/module_ch.cpp:67

} // module OpenDDS

// TAO_IDL - Generated from
// be/be_visitor_module/module_ch.cpp:38

namespace OpenDDS
{

  // TAO_IDL - Generated from
  // be/be_visitor_module/module_ch.cpp:38

  namespace Federator
  {

    // TAO_IDL - Generated from
    // be/be_visitor_sequence/sequence_ch.cpp:102

    typedef ::TAO::DCPS::ZeroCopyDataSeq< OpenDDS::Federator::PublicationUpdate, DCPS_ZERO_COPY_SEQ_DEFAULT_SIZE> PublicationUpdateSeq;
    

    // TAO_IDL - Generated from
    // be/be_interface.cpp:751

#if !defined (_OPENDDS_FEDERATOR_PUBLICATIONUPDATETYPESUPPORT__VAR_OUT_CH_)
#define _OPENDDS_FEDERATOR_PUBLICATIONUPDATETYPESUPPORT__VAR_OUT_CH_

    class PublicationUpdateTypeSupport;
    typedef PublicationUpdateTypeSupport *PublicationUpdateTypeSupport_ptr;

    typedef
      TAO_Objref_Var_T<
          PublicationUpdateTypeSupport
        >
      PublicationUpdateTypeSupport_var;
    
    typedef
      TAO_Objref_Out_T<
          PublicationUpdateTypeSupport
        >
      PublicationUpdateTypeSupport_out;

#endif /* end #if !defined */

    // TAO_IDL - Generated from
    // be/be_visitor_interface/interface_ch.cpp:43

    class OpenDDS_Federator_Export PublicationUpdateTypeSupport
      : public virtual ::OpenDDS::DCPS::TypeSupport
    
    {
    public:

      // TAO_IDL - Generated from
      // be/be_type.cpp:307

      typedef PublicationUpdateTypeSupport_ptr _ptr_type;
      typedef PublicationUpdateTypeSupport_var _var_type;
      typedef PublicationUpdateTypeSupport_out _out_type;

      // The static operations.
      static PublicationUpdateTypeSupport_ptr _duplicate (PublicationUpdateTypeSupport_ptr obj);

      static void _tao_release (PublicationUpdateTypeSupport_ptr obj);

      static PublicationUpdateTypeSupport_ptr _narrow (::CORBA::Object_ptr obj);
      static PublicationUpdateTypeSupport_ptr _unchecked_narrow (::CORBA::Object_ptr obj);
      static PublicationUpdateTypeSupport_ptr _nil (void);

      // TAO_IDL - Generated from
      // be/be_visitor_interface/interface_ch.cpp:140

      virtual ::CORBA::Boolean _is_a (const char *type_id);
      virtual const char* _interface_repository_id (void) const;
      virtual ::CORBA::Boolean marshal (TAO_OutputCDR &cdr);
    
    protected:
      // Abstract or local interface only.
      PublicationUpdateTypeSupport (void);

      

      virtual ~PublicationUpdateTypeSupport (void);
    
    private:
      // Private and unimplemented for concrete interfaces.
      PublicationUpdateTypeSupport (const PublicationUpdateTypeSupport &);

      void operator= (const PublicationUpdateTypeSupport &);
    };

    // TAO_IDL - Generated from
    // be/be_interface.cpp:751

#if !defined (_OPENDDS_FEDERATOR_PUBLICATIONUPDATEDATAWRITER__VAR_OUT_CH_)
#define _OPENDDS_FEDERATOR_PUBLICATIONUPDATEDATAWRITER__VAR_OUT_CH_

    class PublicationUpdateDataWriter;
    typedef PublicationUpdateDataWriter *PublicationUpdateDataWriter_ptr;

    typedef
      TAO_Objref_Var_T<
          PublicationUpdateDataWriter
        >
      PublicationUpdateDataWriter_var;
    
    typedef
      TAO_Objref_Out_T<
          PublicationUpdateDataWriter
        >
      PublicationUpdateDataWriter_out;

#endif /* end #if !defined */

    // TAO_IDL - Generated from
    // be/be_visitor_interface/interface_ch.cpp:43

    class OpenDDS_Federator_Export PublicationUpdateDataWriter
      : public virtual ::DDS::DataWriter
    
    {
    public:

      // TAO_IDL - Generated from
      // be/be_type.cpp:307

      typedef PublicationUpdateDataWriter_ptr _ptr_type;
      typedef PublicationUpdateDataWriter_var _var_type;
      typedef PublicationUpdateDataWriter_out _out_type;

      // The static operations.
      static PublicationUpdateDataWriter_ptr _duplicate (PublicationUpdateDataWriter_ptr obj);

      static void _tao_release (PublicationUpdateDataWriter_ptr obj);

      static PublicationUpdateDataWriter_ptr _narrow (::CORBA::Object_ptr obj);
      static PublicationUpdateDataWriter_ptr _unchecked_narrow (::CORBA::Object_ptr obj);
      static PublicationUpdateDataWriter_ptr _nil (void);

      virtual ::DDS::InstanceHandle_t register_instance (
        const ::OpenDDS::Federator::PublicationUpdate & instance) = 0;

      virtual ::DDS::InstanceHandle_t register_instance_w_timestamp (
        const ::OpenDDS::Federator::PublicationUpdate & instance,
        const ::DDS::Time_t & timestamp) = 0;

      virtual ::DDS::ReturnCode_t unregister_instance (
        const ::OpenDDS::Federator::PublicationUpdate & instance,
        ::DDS::InstanceHandle_t handle) = 0;

      virtual ::DDS::ReturnCode_t unregister_instance_w_timestamp (
        const ::OpenDDS::Federator::PublicationUpdate & instance,
        ::DDS::InstanceHandle_t handle,
        const ::DDS::Time_t & timestamp) = 0;

      virtual ::DDS::ReturnCode_t write (
        const ::OpenDDS::Federator::PublicationUpdate & instance_data,
        ::DDS::InstanceHandle_t handle) = 0;

      virtual ::DDS::ReturnCode_t write_w_timestamp (
        const ::OpenDDS::Federator::PublicationUpdate & instance_data,
        ::DDS::InstanceHandle_t handle,
        const ::DDS::Time_t & source_timestamp) = 0;

      virtual ::DDS::ReturnCode_t dispose (
        const ::OpenDDS::Federator::PublicationUpdate & instance_data,
        ::DDS::InstanceHandle_t instance_handle) = 0;

      virtual ::DDS::ReturnCode_t dispose_w_timestamp (
        const ::OpenDDS::Federator::PublicationUpdate & instance_data,
        ::DDS::InstanceHandle_t instance_handle,
        const ::DDS::Time_t & source_timestamp) = 0;

      virtual ::DDS::ReturnCode_t get_key_value (
        ::OpenDDS::Federator::PublicationUpdate & key_holder,
        ::DDS::InstanceHandle_t handle) = 0;

      virtual ::DDS::InstanceHandle_t lookup_instance (
        const ::OpenDDS::Federator::PublicationUpdate & instance_data) = 0;

      // TAO_IDL - Generated from
      // be/be_visitor_interface/interface_ch.cpp:140

      virtual ::CORBA::Boolean _is_a (const char *type_id);
      virtual const char* _interface_repository_id (void) const;
      virtual ::CORBA::Boolean marshal (TAO_OutputCDR &cdr);
    
    protected:
      // Abstract or local interface only.
      PublicationUpdateDataWriter (void);

      

      virtual ~PublicationUpdateDataWriter (void);
    
    private:
      // Private and unimplemented for concrete interfaces.
      PublicationUpdateDataWriter (const PublicationUpdateDataWriter &);

      void operator= (const PublicationUpdateDataWriter &);
    };

    // TAO_IDL - Generated from
    // be/be_interface.cpp:751

#if !defined (_OPENDDS_FEDERATOR_PUBLICATIONUPDATEDATAREADER__VAR_OUT_CH_)
#define _OPENDDS_FEDERATOR_PUBLICATIONUPDATEDATAREADER__VAR_OUT_CH_

    class PublicationUpdateDataReader;
    typedef PublicationUpdateDataReader *PublicationUpdateDataReader_ptr;

    typedef
      TAO_Objref_Var_T<
          PublicationUpdateDataReader
        >
      PublicationUpdateDataReader_var;
    
    typedef
      TAO_Objref_Out_T<
          PublicationUpdateDataReader
        >
      PublicationUpdateDataReader_out;

#endif /* end #if !defined */

    // TAO_IDL - Generated from
    // be/be_visitor_interface/interface_ch.cpp:43

    class OpenDDS_Federator_Export PublicationUpdateDataReader
      : public virtual ::OpenDDS::DCPS::DataReaderEx
    
    {
    public:

      // TAO_IDL - Generated from
      // be/be_type.cpp:307

      typedef PublicationUpdateDataReader_ptr _ptr_type;
      typedef PublicationUpdateDataReader_var _var_type;
      typedef PublicationUpdateDataReader_out _out_type;

      // The static operations.
      static PublicationUpdateDataReader_ptr _duplicate (PublicationUpdateDataReader_ptr obj);

      static void _tao_release (PublicationUpdateDataReader_ptr obj);

      static PublicationUpdateDataReader_ptr _narrow (::CORBA::Object_ptr obj);
      static PublicationUpdateDataReader_ptr _unchecked_narrow (::CORBA::Object_ptr obj);
      static PublicationUpdateDataReader_ptr _nil (void);

      virtual ::DDS::ReturnCode_t read (
        ::OpenDDS::Federator::PublicationUpdateSeq & received_data,
        ::DDS::SampleInfoSeq & info_seq,
        ::CORBA::Long max_samples,
        ::DDS::SampleStateMask sample_states,
        ::DDS::ViewStateMask view_states,
        ::DDS::InstanceStateMask instance_states) = 0;

      virtual ::DDS::ReturnCode_t take (
        ::OpenDDS::Federator::PublicationUpdateSeq & received_data,
        ::DDS::SampleInfoSeq & info_seq,
        ::CORBA::Long max_samples,
        ::DDS::SampleStateMask sample_states,
        ::DDS::ViewStateMask view_states,
        ::DDS::InstanceStateMask instance_states) = 0;

      virtual ::DDS::ReturnCode_t read_w_condition (
        ::OpenDDS::Federator::PublicationUpdateSeq & data_values,
        ::DDS::SampleInfoSeq & sample_infos,
        ::CORBA::Long max_samples,
        ::DDS::ReadCondition_ptr a_condition) = 0;

      virtual ::DDS::ReturnCode_t take_w_condition (
        ::OpenDDS::Federator::PublicationUpdateSeq & data_values,
        ::DDS::SampleInfoSeq & sample_infos,
        ::CORBA::Long max_samples,
        ::DDS::ReadCondition_ptr a_condition) = 0;

      virtual ::DDS::ReturnCode_t read_next_sample (
        ::OpenDDS::Federator::PublicationUpdate & received_data,
        ::DDS::SampleInfo & sample_info) = 0;

      virtual ::DDS::ReturnCode_t take_next_sample (
        ::OpenDDS::Federator::PublicationUpdate & received_data,
        ::DDS::SampleInfo & sample_info) = 0;

      virtual ::DDS::ReturnCode_t read_instance (
        ::OpenDDS::Federator::PublicationUpdateSeq & received_data,
        ::DDS::SampleInfoSeq & info_seq,
        ::CORBA::Long max_samples,
        ::DDS::InstanceHandle_t a_handle,
        ::DDS::SampleStateMask sample_states,
        ::DDS::ViewStateMask view_states,
        ::DDS::InstanceStateMask instance_states) = 0;

      virtual ::DDS::ReturnCode_t take_instance (
        ::OpenDDS::Federator::PublicationUpdateSeq & received_data,
        ::DDS::SampleInfoSeq & info_seq,
        ::CORBA::Long max_samples,
        ::DDS::InstanceHandle_t a_handle,
        ::DDS::SampleStateMask sample_states,
        ::DDS::ViewStateMask view_states,
        ::DDS::InstanceStateMask instance_states) = 0;

      virtual ::DDS::ReturnCode_t read_instance_w_condition (
        ::OpenDDS::Federator::PublicationUpdateSeq & received_data,
        ::DDS::SampleInfoSeq & sample_infos,
        ::CORBA::Long max_samples,
        ::DDS::InstanceHandle_t a_handle,
        ::DDS::ReadCondition_ptr a_condition) = 0;

      virtual ::DDS::ReturnCode_t take_instance_w_condition (
        ::OpenDDS::Federator::PublicationUpdateSeq & received_data,
        ::DDS::SampleInfoSeq & sample_infos,
        ::CORBA::Long max_samples,
        ::DDS::InstanceHandle_t a_handle,
        ::DDS::ReadCondition_ptr a_condition) = 0;

      virtual ::DDS::ReturnCode_t read_next_instance (
        ::OpenDDS::Federator::PublicationUpdateSeq & received_data,
        ::DDS::SampleInfoSeq & info_seq,
        ::CORBA::Long max_samples,
        ::DDS::InstanceHandle_t a_handle,
        ::DDS::SampleStateMask sample_states,
        ::DDS::ViewStateMask view_states,
        ::DDS::InstanceStateMask instance_states) = 0;

      virtual ::DDS::ReturnCode_t take_next_instance (
        ::OpenDDS::Federator::PublicationUpdateSeq & received_data,
        ::DDS::SampleInfoSeq & info_seq,
        ::CORBA::Long max_samples,
        ::DDS::InstanceHandle_t a_handle,
        ::DDS::SampleStateMask sample_states,
        ::DDS::ViewStateMask view_states,
        ::DDS::InstanceStateMask instance_states) = 0;

      virtual ::DDS::ReturnCode_t read_next_instance_w_condition (
        ::OpenDDS::Federator::PublicationUpdateSeq & data_values,
        ::DDS::SampleInfoSeq & sample_infos,
        ::CORBA::Long max_samples,
        ::DDS::InstanceHandle_t previous_handle,
        ::DDS::ReadCondition_ptr a_condition) = 0;

      virtual ::DDS::ReturnCode_t take_next_instance_w_condition (
        ::OpenDDS::Federator::PublicationUpdateSeq & data_values,
        ::DDS::SampleInfoSeq & sample_infos,
        ::CORBA::Long max_samples,
        ::DDS::InstanceHandle_t previous_handle,
        ::DDS::ReadCondition_ptr a_condition) = 0;

      virtual ::DDS::ReturnCode_t return_loan (
        ::OpenDDS::Federator::PublicationUpdateSeq & received_data,
        ::DDS::SampleInfoSeq & info_seq) = 0;

      virtual ::DDS::ReturnCode_t get_key_value (
        ::OpenDDS::Federator::PublicationUpdate & key_holder,
        ::DDS::InstanceHandle_t handle) = 0;

      virtual ::DDS::InstanceHandle_t lookup_instance (
        const ::OpenDDS::Federator::PublicationUpdate & instance_data) = 0;

      // TAO_IDL - Generated from
      // be/be_visitor_interface/interface_ch.cpp:140

      virtual ::CORBA::Boolean _is_a (const char *type_id);
      virtual const char* _interface_repository_id (void) const;
      virtual ::CORBA::Boolean marshal (TAO_OutputCDR &cdr);
    
    protected:
      // Abstract or local interface only.
      PublicationUpdateDataReader (void);

      

      virtual ~PublicationUpdateDataReader (void);
    
    private:
      // Private and unimplemented for concrete interfaces.
      PublicationUpdateDataReader (const PublicationUpdateDataReader &);

      void operator= (const PublicationUpdateDataReader &);
    };
  
  // TAO_IDL - Generated from
  // be/be_visitor_module/module_ch.cpp:67
  
  } // module OpenDDS::Federator

// TAO_IDL - Generated from
// be/be_visitor_module/module_ch.cpp:67

} // module OpenDDS

// TAO_IDL - Generated from
// be/be_visitor_module/module_ch.cpp:38

namespace OpenDDS
{

  // TAO_IDL - Generated from
  // be/be_visitor_module/module_ch.cpp:38

  namespace Federator
  {

    // TAO_IDL - Generated from
    // be/be_visitor_sequence/sequence_ch.cpp:102

    typedef ::TAO::DCPS::ZeroCopyDataSeq< OpenDDS::Federator::SubscriptionUpdate, DCPS_ZERO_COPY_SEQ_DEFAULT_SIZE> SubscriptionUpdateSeq;
    

    // TAO_IDL - Generated from
    // be/be_interface.cpp:751

#if !defined (_OPENDDS_FEDERATOR_SUBSCRIPTIONUPDATETYPESUPPORT__VAR_OUT_CH_)
#define _OPENDDS_FEDERATOR_SUBSCRIPTIONUPDATETYPESUPPORT__VAR_OUT_CH_

    class SubscriptionUpdateTypeSupport;
    typedef SubscriptionUpdateTypeSupport *SubscriptionUpdateTypeSupport_ptr;

    typedef
      TAO_Objref_Var_T<
          SubscriptionUpdateTypeSupport
        >
      SubscriptionUpdateTypeSupport_var;
    
    typedef
      TAO_Objref_Out_T<
          SubscriptionUpdateTypeSupport
        >
      SubscriptionUpdateTypeSupport_out;

#endif /* end #if !defined */

    // TAO_IDL - Generated from
    // be/be_visitor_interface/interface_ch.cpp:43

    class OpenDDS_Federator_Export SubscriptionUpdateTypeSupport
      : public virtual ::OpenDDS::DCPS::TypeSupport
    
    {
    public:

      // TAO_IDL - Generated from
      // be/be_type.cpp:307

      typedef SubscriptionUpdateTypeSupport_ptr _ptr_type;
      typedef SubscriptionUpdateTypeSupport_var _var_type;
      typedef SubscriptionUpdateTypeSupport_out _out_type;

      // The static operations.
      static SubscriptionUpdateTypeSupport_ptr _duplicate (SubscriptionUpdateTypeSupport_ptr obj);

      static void _tao_release (SubscriptionUpdateTypeSupport_ptr obj);

      static SubscriptionUpdateTypeSupport_ptr _narrow (::CORBA::Object_ptr obj);
      static SubscriptionUpdateTypeSupport_ptr _unchecked_narrow (::CORBA::Object_ptr obj);
      static SubscriptionUpdateTypeSupport_ptr _nil (void);

      // TAO_IDL - Generated from
      // be/be_visitor_interface/interface_ch.cpp:140

      virtual ::CORBA::Boolean _is_a (const char *type_id);
      virtual const char* _interface_repository_id (void) const;
      virtual ::CORBA::Boolean marshal (TAO_OutputCDR &cdr);
    
    protected:
      // Abstract or local interface only.
      SubscriptionUpdateTypeSupport (void);

      

      virtual ~SubscriptionUpdateTypeSupport (void);
    
    private:
      // Private and unimplemented for concrete interfaces.
      SubscriptionUpdateTypeSupport (const SubscriptionUpdateTypeSupport &);

      void operator= (const SubscriptionUpdateTypeSupport &);
    };

    // TAO_IDL - Generated from
    // be/be_interface.cpp:751

#if !defined (_OPENDDS_FEDERATOR_SUBSCRIPTIONUPDATEDATAWRITER__VAR_OUT_CH_)
#define _OPENDDS_FEDERATOR_SUBSCRIPTIONUPDATEDATAWRITER__VAR_OUT_CH_

    class SubscriptionUpdateDataWriter;
    typedef SubscriptionUpdateDataWriter *SubscriptionUpdateDataWriter_ptr;

    typedef
      TAO_Objref_Var_T<
          SubscriptionUpdateDataWriter
        >
      SubscriptionUpdateDataWriter_var;
    
    typedef
      TAO_Objref_Out_T<
          SubscriptionUpdateDataWriter
        >
      SubscriptionUpdateDataWriter_out;

#endif /* end #if !defined */

    // TAO_IDL - Generated from
    // be/be_visitor_interface/interface_ch.cpp:43

    class OpenDDS_Federator_Export SubscriptionUpdateDataWriter
      : public virtual ::DDS::DataWriter
    
    {
    public:

      // TAO_IDL - Generated from
      // be/be_type.cpp:307

      typedef SubscriptionUpdateDataWriter_ptr _ptr_type;
      typedef SubscriptionUpdateDataWriter_var _var_type;
      typedef SubscriptionUpdateDataWriter_out _out_type;

      // The static operations.
      static SubscriptionUpdateDataWriter_ptr _duplicate (SubscriptionUpdateDataWriter_ptr obj);

      static void _tao_release (SubscriptionUpdateDataWriter_ptr obj);

      static SubscriptionUpdateDataWriter_ptr _narrow (::CORBA::Object_ptr obj);
      static SubscriptionUpdateDataWriter_ptr _unchecked_narrow (::CORBA::Object_ptr obj);
      static SubscriptionUpdateDataWriter_ptr _nil (void);

      virtual ::DDS::InstanceHandle_t register_instance (
        const ::OpenDDS::Federator::SubscriptionUpdate & instance) = 0;

      virtual ::DDS::InstanceHandle_t register_instance_w_timestamp (
        const ::OpenDDS::Federator::SubscriptionUpdate & instance,
        const ::DDS::Time_t & timestamp) = 0;

      virtual ::DDS::ReturnCode_t unregister_instance (
        const ::OpenDDS::Federator::SubscriptionUpdate & instance,
        ::DDS::InstanceHandle_t handle) = 0;

      virtual ::DDS::ReturnCode_t unregister_instance_w_timestamp (
        const ::OpenDDS::Federator::SubscriptionUpdate & instance,
        ::DDS::InstanceHandle_t handle,
        const ::DDS::Time_t & timestamp) = 0;

      virtual ::DDS::ReturnCode_t write (
        const ::OpenDDS::Federator::SubscriptionUpdate & instance_data,
        ::DDS::InstanceHandle_t handle) = 0;

      virtual ::DDS::ReturnCode_t write_w_timestamp (
        const ::OpenDDS::Federator::SubscriptionUpdate & instance_data,
        ::DDS::InstanceHandle_t handle,
        const ::DDS::Time_t & source_timestamp) = 0;

      virtual ::DDS::ReturnCode_t dispose (
        const ::OpenDDS::Federator::SubscriptionUpdate & instance_data,
        ::DDS::InstanceHandle_t instance_handle) = 0;

      virtual ::DDS::ReturnCode_t dispose_w_timestamp (
        const ::OpenDDS::Federator::SubscriptionUpdate & instance_data,
        ::DDS::InstanceHandle_t instance_handle,
        const ::DDS::Time_t & source_timestamp) = 0;

      virtual ::DDS::ReturnCode_t get_key_value (
        ::OpenDDS::Federator::SubscriptionUpdate & key_holder,
        ::DDS::InstanceHandle_t handle) = 0;

      virtual ::DDS::InstanceHandle_t lookup_instance (
        const ::OpenDDS::Federator::SubscriptionUpdate & instance_data) = 0;

      // TAO_IDL - Generated from
      // be/be_visitor_interface/interface_ch.cpp:140

      virtual ::CORBA::Boolean _is_a (const char *type_id);
      virtual const char* _interface_repository_id (void) const;
      virtual ::CORBA::Boolean marshal (TAO_OutputCDR &cdr);
    
    protected:
      // Abstract or local interface only.
      SubscriptionUpdateDataWriter (void);

      

      virtual ~SubscriptionUpdateDataWriter (void);
    
    private:
      // Private and unimplemented for concrete interfaces.
      SubscriptionUpdateDataWriter (const SubscriptionUpdateDataWriter &);

      void operator= (const SubscriptionUpdateDataWriter &);
    };

    // TAO_IDL - Generated from
    // be/be_interface.cpp:751

#if !defined (_OPENDDS_FEDERATOR_SUBSCRIPTIONUPDATEDATAREADER__VAR_OUT_CH_)
#define _OPENDDS_FEDERATOR_SUBSCRIPTIONUPDATEDATAREADER__VAR_OUT_CH_

    class SubscriptionUpdateDataReader;
    typedef SubscriptionUpdateDataReader *SubscriptionUpdateDataReader_ptr;

    typedef
      TAO_Objref_Var_T<
          SubscriptionUpdateDataReader
        >
      SubscriptionUpdateDataReader_var;
    
    typedef
      TAO_Objref_Out_T<
          SubscriptionUpdateDataReader
        >
      SubscriptionUpdateDataReader_out;

#endif /* end #if !defined */

    // TAO_IDL - Generated from
    // be/be_visitor_interface/interface_ch.cpp:43

    class OpenDDS_Federator_Export SubscriptionUpdateDataReader
      : public virtual ::OpenDDS::DCPS::DataReaderEx
    
    {
    public:

      // TAO_IDL - Generated from
      // be/be_type.cpp:307

      typedef SubscriptionUpdateDataReader_ptr _ptr_type;
      typedef SubscriptionUpdateDataReader_var _var_type;
      typedef SubscriptionUpdateDataReader_out _out_type;

      // The static operations.
      static SubscriptionUpdateDataReader_ptr _duplicate (SubscriptionUpdateDataReader_ptr obj);

      static void _tao_release (SubscriptionUpdateDataReader_ptr obj);

      static SubscriptionUpdateDataReader_ptr _narrow (::CORBA::Object_ptr obj);
      static SubscriptionUpdateDataReader_ptr _unchecked_narrow (::CORBA::Object_ptr obj);
      static SubscriptionUpdateDataReader_ptr _nil (void);

      virtual ::DDS::ReturnCode_t read (
        ::OpenDDS::Federator::SubscriptionUpdateSeq & received_data,
        ::DDS::SampleInfoSeq & info_seq,
        ::CORBA::Long max_samples,
        ::DDS::SampleStateMask sample_states,
        ::DDS::ViewStateMask view_states,
        ::DDS::InstanceStateMask instance_states) = 0;

      virtual ::DDS::ReturnCode_t take (
        ::OpenDDS::Federator::SubscriptionUpdateSeq & received_data,
        ::DDS::SampleInfoSeq & info_seq,
        ::CORBA::Long max_samples,
        ::DDS::SampleStateMask sample_states,
        ::DDS::ViewStateMask view_states,
        ::DDS::InstanceStateMask instance_states) = 0;

      virtual ::DDS::ReturnCode_t read_w_condition (
        ::OpenDDS::Federator::SubscriptionUpdateSeq & data_values,
        ::DDS::SampleInfoSeq & sample_infos,
        ::CORBA::Long max_samples,
        ::DDS::ReadCondition_ptr a_condition) = 0;

      virtual ::DDS::ReturnCode_t take_w_condition (
        ::OpenDDS::Federator::SubscriptionUpdateSeq & data_values,
        ::DDS::SampleInfoSeq & sample_infos,
        ::CORBA::Long max_samples,
        ::DDS::ReadCondition_ptr a_condition) = 0;

      virtual ::DDS::ReturnCode_t read_next_sample (
        ::OpenDDS::Federator::SubscriptionUpdate & received_data,
        ::DDS::SampleInfo & sample_info) = 0;

      virtual ::DDS::ReturnCode_t take_next_sample (
        ::OpenDDS::Federator::SubscriptionUpdate & received_data,
        ::DDS::SampleInfo & sample_info) = 0;

      virtual ::DDS::ReturnCode_t read_instance (
        ::OpenDDS::Federator::SubscriptionUpdateSeq & received_data,
        ::DDS::SampleInfoSeq & info_seq,
        ::CORBA::Long max_samples,
        ::DDS::InstanceHandle_t a_handle,
        ::DDS::SampleStateMask sample_states,
        ::DDS::ViewStateMask view_states,
        ::DDS::InstanceStateMask instance_states) = 0;

      virtual ::DDS::ReturnCode_t take_instance (
        ::OpenDDS::Federator::SubscriptionUpdateSeq & received_data,
        ::DDS::SampleInfoSeq & info_seq,
        ::CORBA::Long max_samples,
        ::DDS::InstanceHandle_t a_handle,
        ::DDS::SampleStateMask sample_states,
        ::DDS::ViewStateMask view_states,
        ::DDS::InstanceStateMask instance_states) = 0;

      virtual ::DDS::ReturnCode_t read_instance_w_condition (
        ::OpenDDS::Federator::SubscriptionUpdateSeq & received_data,
        ::DDS::SampleInfoSeq & sample_infos,
        ::CORBA::Long max_samples,
        ::DDS::InstanceHandle_t a_handle,
        ::DDS::ReadCondition_ptr a_condition) = 0;

      virtual ::DDS::ReturnCode_t take_instance_w_condition (
        ::OpenDDS::Federator::SubscriptionUpdateSeq & received_data,
        ::DDS::SampleInfoSeq & sample_infos,
        ::CORBA::Long max_samples,
        ::DDS::InstanceHandle_t a_handle,
        ::DDS::ReadCondition_ptr a_condition) = 0;

      virtual ::DDS::ReturnCode_t read_next_instance (
        ::OpenDDS::Federator::SubscriptionUpdateSeq & received_data,
        ::DDS::SampleInfoSeq & info_seq,
        ::CORBA::Long max_samples,
        ::DDS::InstanceHandle_t a_handle,
        ::DDS::SampleStateMask sample_states,
        ::DDS::ViewStateMask view_states,
        ::DDS::InstanceStateMask instance_states) = 0;

      virtual ::DDS::ReturnCode_t take_next_instance (
        ::OpenDDS::Federator::SubscriptionUpdateSeq & received_data,
        ::DDS::SampleInfoSeq & info_seq,
        ::CORBA::Long max_samples,
        ::DDS::InstanceHandle_t a_handle,
        ::DDS::SampleStateMask sample_states,
        ::DDS::ViewStateMask view_states,
        ::DDS::InstanceStateMask instance_states) = 0;

      virtual ::DDS::ReturnCode_t read_next_instance_w_condition (
        ::OpenDDS::Federator::SubscriptionUpdateSeq & data_values,
        ::DDS::SampleInfoSeq & sample_infos,
        ::CORBA::Long max_samples,
        ::DDS::InstanceHandle_t previous_handle,
        ::DDS::ReadCondition_ptr a_condition) = 0;

      virtual ::DDS::ReturnCode_t take_next_instance_w_condition (
        ::OpenDDS::Federator::SubscriptionUpdateSeq & data_values,
        ::DDS::SampleInfoSeq & sample_infos,
        ::CORBA::Long max_samples,
        ::DDS::InstanceHandle_t previous_handle,
        ::DDS::ReadCondition_ptr a_condition) = 0;

      virtual ::DDS::ReturnCode_t return_loan (
        ::OpenDDS::Federator::SubscriptionUpdateSeq & received_data,
        ::DDS::SampleInfoSeq & info_seq) = 0;

      virtual ::DDS::ReturnCode_t get_key_value (
        ::OpenDDS::Federator::SubscriptionUpdate & key_holder,
        ::DDS::InstanceHandle_t handle) = 0;

      virtual ::DDS::InstanceHandle_t lookup_instance (
        const ::OpenDDS::Federator::SubscriptionUpdate & instance_data) = 0;

      // TAO_IDL - Generated from
      // be/be_visitor_interface/interface_ch.cpp:140

      virtual ::CORBA::Boolean _is_a (const char *type_id);
      virtual const char* _interface_repository_id (void) const;
      virtual ::CORBA::Boolean marshal (TAO_OutputCDR &cdr);
    
    protected:
      // Abstract or local interface only.
      SubscriptionUpdateDataReader (void);

      

      virtual ~SubscriptionUpdateDataReader (void);
    
    private:
      // Private and unimplemented for concrete interfaces.
      SubscriptionUpdateDataReader (const SubscriptionUpdateDataReader &);

      void operator= (const SubscriptionUpdateDataReader &);
    };
  
  // TAO_IDL - Generated from
  // be/be_visitor_module/module_ch.cpp:67
  
  } // module OpenDDS::Federator

// TAO_IDL - Generated from
// be/be_visitor_module/module_ch.cpp:67

} // module OpenDDS

// TAO_IDL - Generated from
// be/be_visitor_arg_traits.cpp:68


OPENDDS_END_VERSIONED_NAMESPACE_DECL


TAO_BEGIN_VERSIONED_NAMESPACE_DECL


// Arg traits specializations.
namespace TAO
{
}

TAO_END_VERSIONED_NAMESPACE_DECL


OPENDDS_BEGIN_VERSIONED_NAMESPACE_DECL




// TAO_IDL - Generated from
// be/be_visitor_traits.cpp:62


OPENDDS_END_VERSIONED_NAMESPACE_DECL


TAO_BEGIN_VERSIONED_NAMESPACE_DECL

// Traits specializations.
namespace TAO
{

#if !defined (_OPENDDS_FEDERATOR_OWNERUPDATETYPESUPPORT__TRAITS_)
#define _OPENDDS_FEDERATOR_OWNERUPDATETYPESUPPORT__TRAITS_

  template<>
  struct OpenDDS_Federator_Export Objref_Traits< ::OpenDDS::Federator::OwnerUpdateTypeSupport>
  {
    static ::OpenDDS::Federator::OwnerUpdateTypeSupport_ptr duplicate (
        ::OpenDDS::Federator::OwnerUpdateTypeSupport_ptr p);
    static void release (
        ::OpenDDS::Federator::OwnerUpdateTypeSupport_ptr p);
    static ::OpenDDS::Federator::OwnerUpdateTypeSupport_ptr nil (void);
    static ::CORBA::Boolean marshal (
        const ::OpenDDS::Federator::OwnerUpdateTypeSupport_ptr p,
        TAO_OutputCDR & cdr);
  };

#endif /* end #if !defined */

#if !defined (_OPENDDS_FEDERATOR_OWNERUPDATEDATAWRITER__TRAITS_)
#define _OPENDDS_FEDERATOR_OWNERUPDATEDATAWRITER__TRAITS_

  template<>
  struct OpenDDS_Federator_Export Objref_Traits< ::OpenDDS::Federator::OwnerUpdateDataWriter>
  {
    static ::OpenDDS::Federator::OwnerUpdateDataWriter_ptr duplicate (
        ::OpenDDS::Federator::OwnerUpdateDataWriter_ptr p);
    static void release (
        ::OpenDDS::Federator::OwnerUpdateDataWriter_ptr p);
    static ::OpenDDS::Federator::OwnerUpdateDataWriter_ptr nil (void);
    static ::CORBA::Boolean marshal (
        const ::OpenDDS::Federator::OwnerUpdateDataWriter_ptr p,
        TAO_OutputCDR & cdr);
  };

#endif /* end #if !defined */

#if !defined (_OPENDDS_FEDERATOR_OWNERUPDATEDATAREADER__TRAITS_)
#define _OPENDDS_FEDERATOR_OWNERUPDATEDATAREADER__TRAITS_

  template<>
  struct OpenDDS_Federator_Export Objref_Traits< ::OpenDDS::Federator::OwnerUpdateDataReader>
  {
    static ::OpenDDS::Federator::OwnerUpdateDataReader_ptr duplicate (
        ::OpenDDS::Federator::OwnerUpdateDataReader_ptr p);
    static void release (
        ::OpenDDS::Federator::OwnerUpdateDataReader_ptr p);
    static ::OpenDDS::Federator::OwnerUpdateDataReader_ptr nil (void);
    static ::CORBA::Boolean marshal (
        const ::OpenDDS::Federator::OwnerUpdateDataReader_ptr p,
        TAO_OutputCDR & cdr);
  };

#endif /* end #if !defined */

#if !defined (_OPENDDS_FEDERATOR_TOPICUPDATETYPESUPPORT__TRAITS_)
#define _OPENDDS_FEDERATOR_TOPICUPDATETYPESUPPORT__TRAITS_

  template<>
  struct OpenDDS_Federator_Export Objref_Traits< ::OpenDDS::Federator::TopicUpdateTypeSupport>
  {
    static ::OpenDDS::Federator::TopicUpdateTypeSupport_ptr duplicate (
        ::OpenDDS::Federator::TopicUpdateTypeSupport_ptr p);
    static void release (
        ::OpenDDS::Federator::TopicUpdateTypeSupport_ptr p);
    static ::OpenDDS::Federator::TopicUpdateTypeSupport_ptr nil (void);
    static ::CORBA::Boolean marshal (
        const ::OpenDDS::Federator::TopicUpdateTypeSupport_ptr p,
        TAO_OutputCDR & cdr);
  };

#endif /* end #if !defined */

#if !defined (_OPENDDS_FEDERATOR_TOPICUPDATEDATAWRITER__TRAITS_)
#define _OPENDDS_FEDERATOR_TOPICUPDATEDATAWRITER__TRAITS_

  template<>
  struct OpenDDS_Federator_Export Objref_Traits< ::OpenDDS::Federator::TopicUpdateDataWriter>
  {
    static ::OpenDDS::Federator::TopicUpdateDataWriter_ptr duplicate (
        ::OpenDDS::Federator::TopicUpdateDataWriter_ptr p);
    static void release (
        ::OpenDDS::Federator::TopicUpdateDataWriter_ptr p);
    static ::OpenDDS::Federator::TopicUpdateDataWriter_ptr nil (void);
    static ::CORBA::Boolean marshal (
        const ::OpenDDS::Federator::TopicUpdateDataWriter_ptr p,
        TAO_OutputCDR & cdr);
  };

#endif /* end #if !defined */

#if !defined (_OPENDDS_FEDERATOR_TOPICUPDATEDATAREADER__TRAITS_)
#define _OPENDDS_FEDERATOR_TOPICUPDATEDATAREADER__TRAITS_

  template<>
  struct OpenDDS_Federator_Export Objref_Traits< ::OpenDDS::Federator::TopicUpdateDataReader>
  {
    static ::OpenDDS::Federator::TopicUpdateDataReader_ptr duplicate (
        ::OpenDDS::Federator::TopicUpdateDataReader_ptr p);
    static void release (
        ::OpenDDS::Federator::TopicUpdateDataReader_ptr p);
    static ::OpenDDS::Federator::TopicUpdateDataReader_ptr nil (void);
    static ::CORBA::Boolean marshal (
        const ::OpenDDS::Federator::TopicUpdateDataReader_ptr p,
        TAO_OutputCDR & cdr);
  };

#endif /* end #if !defined */

#if !defined (_OPENDDS_FEDERATOR_PARTICIPANTUPDATETYPESUPPORT__TRAITS_)
#define _OPENDDS_FEDERATOR_PARTICIPANTUPDATETYPESUPPORT__TRAITS_

  template<>
  struct OpenDDS_Federator_Export Objref_Traits< ::OpenDDS::Federator::ParticipantUpdateTypeSupport>
  {
    static ::OpenDDS::Federator::ParticipantUpdateTypeSupport_ptr duplicate (
        ::OpenDDS::Federator::ParticipantUpdateTypeSupport_ptr p);
    static void release (
        ::OpenDDS::Federator::ParticipantUpdateTypeSupport_ptr p);
    static ::OpenDDS::Federator::ParticipantUpdateTypeSupport_ptr nil (void);
    static ::CORBA::Boolean marshal (
        const ::OpenDDS::Federator::ParticipantUpdateTypeSupport_ptr p,
        TAO_OutputCDR & cdr);
  };

#endif /* end #if !defined */

#if !defined (_OPENDDS_FEDERATOR_PARTICIPANTUPDATEDATAWRITER__TRAITS_)
#define _OPENDDS_FEDERATOR_PARTICIPANTUPDATEDATAWRITER__TRAITS_

  template<>
  struct OpenDDS_Federator_Export Objref_Traits< ::OpenDDS::Federator::ParticipantUpdateDataWriter>
  {
    static ::OpenDDS::Federator::ParticipantUpdateDataWriter_ptr duplicate (
        ::OpenDDS::Federator::ParticipantUpdateDataWriter_ptr p);
    static void release (
        ::OpenDDS::Federator::ParticipantUpdateDataWriter_ptr p);
    static ::OpenDDS::Federator::ParticipantUpdateDataWriter_ptr nil (void);
    static ::CORBA::Boolean marshal (
        const ::OpenDDS::Federator::ParticipantUpdateDataWriter_ptr p,
        TAO_OutputCDR & cdr);
  };

#endif /* end #if !defined */

#if !defined (_OPENDDS_FEDERATOR_PARTICIPANTUPDATEDATAREADER__TRAITS_)
#define _OPENDDS_FEDERATOR_PARTICIPANTUPDATEDATAREADER__TRAITS_

  template<>
  struct OpenDDS_Federator_Export Objref_Traits< ::OpenDDS::Federator::ParticipantUpdateDataReader>
  {
    static ::OpenDDS::Federator::ParticipantUpdateDataReader_ptr duplicate (
        ::OpenDDS::Federator::ParticipantUpdateDataReader_ptr p);
    static void release (
        ::OpenDDS::Federator::ParticipantUpdateDataReader_ptr p);
    static ::OpenDDS::Federator::ParticipantUpdateDataReader_ptr nil (void);
    static ::CORBA::Boolean marshal (
        const ::OpenDDS::Federator::ParticipantUpdateDataReader_ptr p,
        TAO_OutputCDR & cdr);
  };

#endif /* end #if !defined */

#if !defined (_OPENDDS_FEDERATOR_PUBLICATIONUPDATETYPESUPPORT__TRAITS_)
#define _OPENDDS_FEDERATOR_PUBLICATIONUPDATETYPESUPPORT__TRAITS_

  template<>
  struct OpenDDS_Federator_Export Objref_Traits< ::OpenDDS::Federator::PublicationUpdateTypeSupport>
  {
    static ::OpenDDS::Federator::PublicationUpdateTypeSupport_ptr duplicate (
        ::OpenDDS::Federator::PublicationUpdateTypeSupport_ptr p);
    static void release (
        ::OpenDDS::Federator::PublicationUpdateTypeSupport_ptr p);
    static ::OpenDDS::Federator::PublicationUpdateTypeSupport_ptr nil (void);
    static ::CORBA::Boolean marshal (
        const ::OpenDDS::Federator::PublicationUpdateTypeSupport_ptr p,
        TAO_OutputCDR & cdr);
  };

#endif /* end #if !defined */

#if !defined (_OPENDDS_FEDERATOR_PUBLICATIONUPDATEDATAWRITER__TRAITS_)
#define _OPENDDS_FEDERATOR_PUBLICATIONUPDATEDATAWRITER__TRAITS_

  template<>
  struct OpenDDS_Federator_Export Objref_Traits< ::OpenDDS::Federator::PublicationUpdateDataWriter>
  {
    static ::OpenDDS::Federator::PublicationUpdateDataWriter_ptr duplicate (
        ::OpenDDS::Federator::PublicationUpdateDataWriter_ptr p);
    static void release (
        ::OpenDDS::Federator::PublicationUpdateDataWriter_ptr p);
    static ::OpenDDS::Federator::PublicationUpdateDataWriter_ptr nil (void);
    static ::CORBA::Boolean marshal (
        const ::OpenDDS::Federator::PublicationUpdateDataWriter_ptr p,
        TAO_OutputCDR & cdr);
  };

#endif /* end #if !defined */

#if !defined (_OPENDDS_FEDERATOR_PUBLICATIONUPDATEDATAREADER__TRAITS_)
#define _OPENDDS_FEDERATOR_PUBLICATIONUPDATEDATAREADER__TRAITS_

  template<>
  struct OpenDDS_Federator_Export Objref_Traits< ::OpenDDS::Federator::PublicationUpdateDataReader>
  {
    static ::OpenDDS::Federator::PublicationUpdateDataReader_ptr duplicate (
        ::OpenDDS::Federator::PublicationUpdateDataReader_ptr p);
    static void release (
        ::OpenDDS::Federator::PublicationUpdateDataReader_ptr p);
    static ::OpenDDS::Federator::PublicationUpdateDataReader_ptr nil (void);
    static ::CORBA::Boolean marshal (
        const ::OpenDDS::Federator::PublicationUpdateDataReader_ptr p,
        TAO_OutputCDR & cdr);
  };

#endif /* end #if !defined */

#if !defined (_OPENDDS_FEDERATOR_SUBSCRIPTIONUPDATETYPESUPPORT__TRAITS_)
#define _OPENDDS_FEDERATOR_SUBSCRIPTIONUPDATETYPESUPPORT__TRAITS_

  template<>
  struct OpenDDS_Federator_Export Objref_Traits< ::OpenDDS::Federator::SubscriptionUpdateTypeSupport>
  {
    static ::OpenDDS::Federator::SubscriptionUpdateTypeSupport_ptr duplicate (
        ::OpenDDS::Federator::SubscriptionUpdateTypeSupport_ptr p);
    static void release (
        ::OpenDDS::Federator::SubscriptionUpdateTypeSupport_ptr p);
    static ::OpenDDS::Federator::SubscriptionUpdateTypeSupport_ptr nil (void);
    static ::CORBA::Boolean marshal (
        const ::OpenDDS::Federator::SubscriptionUpdateTypeSupport_ptr p,
        TAO_OutputCDR & cdr);
  };

#endif /* end #if !defined */

#if !defined (_OPENDDS_FEDERATOR_SUBSCRIPTIONUPDATEDATAWRITER__TRAITS_)
#define _OPENDDS_FEDERATOR_SUBSCRIPTIONUPDATEDATAWRITER__TRAITS_

  template<>
  struct OpenDDS_Federator_Export Objref_Traits< ::OpenDDS::Federator::SubscriptionUpdateDataWriter>
  {
    static ::OpenDDS::Federator::SubscriptionUpdateDataWriter_ptr duplicate (
        ::OpenDDS::Federator::SubscriptionUpdateDataWriter_ptr p);
    static void release (
        ::OpenDDS::Federator::SubscriptionUpdateDataWriter_ptr p);
    static ::OpenDDS::Federator::SubscriptionUpdateDataWriter_ptr nil (void);
    static ::CORBA::Boolean marshal (
        const ::OpenDDS::Federator::SubscriptionUpdateDataWriter_ptr p,
        TAO_OutputCDR & cdr);
  };

#endif /* end #if !defined */

#if !defined (_OPENDDS_FEDERATOR_SUBSCRIPTIONUPDATEDATAREADER__TRAITS_)
#define _OPENDDS_FEDERATOR_SUBSCRIPTIONUPDATEDATAREADER__TRAITS_

  template<>
  struct OpenDDS_Federator_Export Objref_Traits< ::OpenDDS::Federator::SubscriptionUpdateDataReader>
  {
    static ::OpenDDS::Federator::SubscriptionUpdateDataReader_ptr duplicate (
        ::OpenDDS::Federator::SubscriptionUpdateDataReader_ptr p);
    static void release (
        ::OpenDDS::Federator::SubscriptionUpdateDataReader_ptr p);
    static ::OpenDDS::Federator::SubscriptionUpdateDataReader_ptr nil (void);
    static ::CORBA::Boolean marshal (
        const ::OpenDDS::Federator::SubscriptionUpdateDataReader_ptr p,
        TAO_OutputCDR & cdr);
  };

#endif /* end #if !defined */
}
TAO_END_VERSIONED_NAMESPACE_DECL


OPENDDS_BEGIN_VERSIONED_NAMESPACE_DECL




// TAO_IDL - Generated from
// be/be_codegen.cpp:1703


OPENDDS_END_VERSIONED_NAMESPACE_DECL

#if defined (__ACE_INLINE__)
#include "FederatorTypeSupportC.inl"
#endif /* defined INLINE */

#include /**/ "ace/post.h"

#endif /* ifndef */

